/**
 * Copyright (c) 2022, Salesforce, Inc.,
 * All rights reserved.
 * For full license text, see the LICENSE.txt file
 */

/*
 *  ATTENTION!
 *  THIS IS A GENERATED FILE FROM https://github.com/salesforce-experience-platform-emu/lds-lightning-platform
 *  If you would like to contribute to LDS, please follow the steps outlined in the git repo.
 *  Any changes made to this file in p4 will be automatically overwritten.
 *  *******************************************************************************************
 */
/* proxy-compat-disable */
import { HttpStatusCode as HttpStatusCode$1 } from 'force/luvioEngine';
import { getTransactionKey as getTransactionKey$1, UIAPI_GET_LAYOUT, UIAPI_GET_LAYOUT_USER_STATE, UIAPI_OBJECT_INFO_BATCH_PATH, UIAPI_OBJECT_INFO_PATH, shouldForceRefresh, createOkResponse as createOkResponse$1, layoutUserStateStorage, layoutUserStateStorageStatsLogger, layoutStorage, layoutStorageStatsLogger, objectInfoStorage, objectInfoStorageStatsLogger } from 'force/ldsNetwork';

/**
 * Copyright (c) 2022, Salesforce, Inc.,
 * All rights reserved.
 * For full license text, see the LICENSE.txt file
 */

function e$1(e){this.message=e;}e$1.prototype=new Error,e$1.prototype.name="InvalidCharacterError";var r$1="undefined"!=typeof window&&window.atob&&window.atob.bind(window)||function(r){var t=String(r).replace(/=+$/,"");if(t.length%4==1)throw new e$1("'atob' failed: The string to be decoded is not correctly encoded.");for(var n,o,a=0,i=0,c="";o=t.charAt(i++);~o&&(n=a%4?64*n+o:o,a++%4)?c+=String.fromCharCode(255&n>>(-2*a&6)):0)o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(o);return c};function t$1(e){var t=e.replace(/-/g,"+").replace(/_/g,"/");switch(t.length%4){case 0:break;case 2:t+="==";break;case 3:t+="=";break;default:throw "Illegal base64url string!"}try{return function(e){return decodeURIComponent(r$1(e).replace(/(.)/g,(function(e,r){var t=r.charCodeAt(0).toString(16).toUpperCase();return t.length<2&&(t="0"+t),"%"+t})))}(t)}catch(e){return r$1(t)}}function n$1(e){this.message=e;}function o$1(e,r){if("string"!=typeof e)throw new n$1("Invalid token specified");var o=!0===(r=r||{}).header?0:1;try{return JSON.parse(t$1(e.split(".")[o]))}catch(e){throw new n$1("Invalid token specified: "+e.message)}}n$1.prototype=new Error,n$1.prototype.name="InvalidTokenError";

/**
 * Copyright (c) 2022, Salesforce, Inc.,
 * All rights reserved.
 * For full license text, see the LICENSE.txt file
 */

const LogLevelMap = {
    TRACE: 4,
    DEBUG: 3,
    INFO: 2,
    WARN: 1,
    ERROR: 0,
};
/**
 * A simple Logger implementation.
 */
class ConsoleLogger {
    constructor(level = 'WARN', 
    // eslint-disable-next-line no-console
    printer = console.log, formatter = (level, message) => `${level}: ${message}`) {
        this.level = level;
        this.printer = printer;
        this.formatter = formatter;
        this.messages = [];
    }
    trace(message) {
        this.log('TRACE', message);
    }
    debug(message) {
        this.log('DEBUG', message);
    }
    info(message) {
        this.log('INFO', message);
    }
    warn(message) {
        this.log('WARN', message);
    }
    error(message) {
        this.log('ERROR', message);
    }
    log(level, message) {
        if (LogLevelMap[level] > LogLevelMap[this.level]) {
            return;
        }
        this.printer(this.formatter(level, message));
    }
}
/**
 * Constructs a new LoggerService.
 */
function loggerService(level, printer, formatter) {
    return new ConsoleLogger(level, printer, formatter);
}

/**
 * Represents a JWT token with its decoded info and optional extra info.
 *
 * @typeparam T - Type of the additional payload in the JWT.
 * @typeparam ExtraInfo - Type of the additional information.
 */
class JwtToken {
    /**
     * Create a new JwtToken.
     *
     * @param _token - The JWT string.
     * @param _decodedInfo - The decoded information from the JWT.
     * @param _extraInfo - Any additional information associated with the JWT.
     */
    constructor(_token, _decodedInfo, _extraInfo) {
        this._token = _token;
        this._decodedInfo = _decodedInfo;
        this._extraInfo = _extraInfo;
    }
    /**
     * Get the JWT string.
     *
     * @returns The JWT string.
     */
    get token() {
        return this._token;
    }
    /**
     * Get the additional information associated with the JWT.
     *
     * @returns The additional information.
     */
    get extraInfo() {
        return this._extraInfo;
    }
    /**
     * Get the decoded information from the JWT.
     *
     * @returns The decoded information.
     */
    get decodedInfo() {
        return this._decodedInfo;
    }
    /**
     * Get the remaining time in seconds until the JWT expires.
     *
     * @returns The remaining time in seconds.
     */
    get tokenRemainingSeconds() {
        return this.decodedInfo.exp - Date.now() / 1000;
    }
    /**
     * Check if the JWT is expired.
     *
     * @returns True if the JWT is expired, false otherwise.
     */
    get isExpired() {
        return this.tokenRemainingSeconds <= 0;
    }
}

/**
 * Default logger if none is provided. Is overwritten in non-production environments.
 */
let defaultLogger = {
    trace: () => { },
    debug: () => { },
    info: () => { },
    warn: () => { },
    error: () => { },
};
if (process.env.NODE_ENV !== 'production') {
    defaultLogger = loggerService();
}
/**
 * Decodes JWT token information and provides a default expiry if none is present.
 *
 * @param token - JWT token as a string.
 * @param defaultTokenTTLInSeconds - Default expiry time in seconds if "exp" claim is not present in token.
 * @param logger - Logger for logging warnings and errors.
 *
 * @returns An object of decoded JWT token information.
 */
function computeDecodedInfo(token, defaultTokenTTLInSeconds, logger) {
    const decodedInfo = o$1(token);
    if (decodedInfo.exp === undefined) {
        logger.warn(`"exp" claim is not present in the provided token.`);
        decodedInfo.exp = Date.now() / 1000 + defaultTokenTTLInSeconds;
    }
    return decodedInfo;
}
/**
 * A repository for JWT tokens.
 */
class JwtRepository {
    /**
     * @param limitInSeconds - Time in seconds before the token's expiry to notify observers.
     * @param defaultTokenTTLInSeconds - Default token expiry time in seconds if "exp" claim is not present in token.
     * @param logger - Logger for logging warnings and errors.
     */
    constructor(limitInSeconds = 5, defaultTokenTTLInSeconds = 120, logger = defaultLogger) {
        this.limitInSeconds = limitInSeconds;
        this.defaultTokenTTLInSeconds = defaultTokenTTLInSeconds;
        this.logger = logger;
        this.observers = [];
    }
    /**
     * Get the current token.
     */
    get token() {
        return this._token;
    }
    /**
     * Set the current token.
     *
     * @param token - JWT token as a string.
     * @param extraInfo - Optional extra information.
     */
    setToken(token, extraInfo) {
        const decodedInfo = computeDecodedInfo(token, this.defaultTokenTTLInSeconds, this.logger);
        this._token = new JwtToken(token, decodedInfo, extraInfo);
        this.observeTokenExpiration();
        return this._token;
    }
    /**
     * Remove the current token.
     */
    removeToken() {
        this._token = undefined;
        this.clearTimeoutHandler();
    }
    /**
     * Subscribe to the token nearing its expiration.
     *
     * @param cb - Callback function to execute when token is nearing expiration.
     */
    subscribeToTokenNearExpiration(cb) {
        this.observers.push(cb);
        this.observeTokenExpiration();
        return () => {
            this.observers = this.observers.filter((observer) => observer !== cb);
        };
    }
    /**
     * Clear the timeout handler.
     */
    clearTimeoutHandler() {
        if (this.timeoutHandler !== undefined) {
            clearTimeout(this.timeoutHandler);
        }
    }
    /**
     * Observe and handle token expiration.
     */
    observeTokenExpiration() {
        this.clearTimeoutHandler();
        if (this.observers.length === 0 || this.token === undefined) {
            return;
        }
        this.timeoutHandler = setTimeout(() => this.notifyTokenIsExpiring(), this.computeTimeoutTimeInMs());
    }
    /**
     * Compute the timeout time in milliseconds.
     */
    computeTimeoutTimeInMs() {
        const remainingSeconds = this.token.tokenRemainingSeconds;
        let timeoutTimeInSeconds = remainingSeconds - this.limitInSeconds;
        return timeoutTimeInSeconds < 0 ? 0 : timeoutTimeInSeconds * 1000;
    }
    /**
     * Notify all observers that the token is expiring.
     */
    notifyTokenIsExpiring() {
        this.observers.forEach((cb) => {
            try {
                cb.call(undefined, this.token);
            }
            catch (e) {
                this.logger.error(e.message);
            }
        });
    }
}

/**
 * JwtManager class.
 * It provides methods for managing JWT (Json Web Token), such as retrieving and refreshing.
 *
 * @template T The data type the JwtToken carries. Default to unknown.
 * @template ExtraInfo The type of the optional extra information returned by the getJwt method. Defaults to undefined.
 * @property {JwtRepository<T, ExtraInfo>} jwtRepository JwtRepository instance used for token management.
 * @property {JwtResolver<ExtraInfo>} resolver JwtResolver instance used for token retrieval.
 */
class JwtManager {
    /**
     * Constructor for JwtManager class.
     *
     * @param {JwtRepository<T, ExtraInfo>} jwtRepository JwtRepository instance used for token management.
     * @param {JwtResolver<ExtraInfo>} resolver JwtResolver instance used for token retrieval.
     * @param {JwtManagerOptions} options JwtManagerOptions bag to customize behavior.
     */
    constructor(jwtRepository, resolver, options) {
        this.jwtRepository = jwtRepository;
        this.resolver = resolver;
        if (options === null || options === void 0 ? void 0 : options.keepTokenUpdated) {
            jwtRepository.subscribeToTokenNearExpiration(() => this.refreshToken());
        }
    }
    /**
     * Method to get a JWT token.
     * If there's a token request in progress, it will return the Promise of this request.
     * If the current token is undefined or expired, it will initiate a token refresh.
     * Otherwise, it will return the current token.
     *
     * @returns {JwtToken<T, ExtraInfo> | Promise<JwtToken<T, ExtraInfo>>} The current token or the Promise of a token request.
     */
    getJwt() {
        if (this.inflightPromise) {
            return this.inflightPromise;
        }
        const token = this.jwtRepository.token;
        if (token === undefined || token.isExpired) {
            return this.refreshToken();
        }
        return token;
    }
    /**
     * Method to refresh a JWT token.
     * If a refresh request is already in progress, it will return the Promise of this request.
     * Otherwise, it will start a new refresh request and return its Promise.
     *
     * @returns {Promise<JwtToken<T, ExtraInfo>>} Promise of the refreshed token.
     */
    refreshToken() {
        if (this.inflightPromise === undefined) {
            this.inflightPromise = new Promise((resolve, reject) => {
                this.resolver
                    .getJwt()
                    .then(({ jwt, extraInfo }) => {
                    this.inflightPromise = undefined;
                    const token = this.jwtRepository.setToken(jwt, extraInfo);
                    resolve(token);
                })
                    .catch((reason) => {
                    this.inflightPromise = undefined;
                    reject(reason);
                });
            });
        }
        return this.inflightPromise;
    }
    /**
     * Method to check if a token refresh is in progress.
     *
     * @returns {boolean} true if a token refresh is in progress, false otherwise.
     */
    get isRefreshingToken() {
        return this.inflightPromise !== undefined;
    }
}

var SnapshotState;
(function (SnapshotState) {
    SnapshotState["Fulfilled"] = "Fulfilled";
    SnapshotState["Unfulfilled"] = "Unfulfilled";
    SnapshotState["Error"] = "Error";
    SnapshotState["Pending"] = "Pending";
    SnapshotState["Stale"] = "Stale";
})(SnapshotState || (SnapshotState = {}));
const { isArray: isArray$1 } = Array;

Promise.resolve();

var StoreErrorStatus;
(function (StoreErrorStatus) {
    StoreErrorStatus[StoreErrorStatus["RESOURCE_NOT_FOUND"] = 404] = "RESOURCE_NOT_FOUND";
})(StoreErrorStatus || (StoreErrorStatus = {}));
var StoreRecordType;
(function (StoreRecordType) {
    StoreRecordType["Error"] = "error";
})(StoreRecordType || (StoreRecordType = {}));
var StoreLinkStateValues$1;
(function (StoreLinkStateValues) {
    StoreLinkStateValues[StoreLinkStateValues["NotPresent"] = 0] = "NotPresent";
    StoreLinkStateValues[StoreLinkStateValues["RefNotPresent"] = 1] = "RefNotPresent";
    StoreLinkStateValues[StoreLinkStateValues["RefPresent"] = 2] = "RefPresent";
    StoreLinkStateValues[StoreLinkStateValues["Null"] = 3] = "Null";
    StoreLinkStateValues[StoreLinkStateValues["Missing"] = 4] = "Missing";
    StoreLinkStateValues[StoreLinkStateValues["Pending"] = 5] = "Pending";
})(StoreLinkStateValues$1 || (StoreLinkStateValues$1 = {}));
var StoreResolveResultState;
(function (StoreResolveResultState) {
    StoreResolveResultState[StoreResolveResultState["Found"] = 0] = "Found";
    StoreResolveResultState[StoreResolveResultState["Error"] = 1] = "Error";
    StoreResolveResultState[StoreResolveResultState["Null"] = 2] = "Null";
    StoreResolveResultState[StoreResolveResultState["NotPresent"] = 3] = "NotPresent";
    StoreResolveResultState[StoreResolveResultState["Stale"] = 4] = "Stale";
})(StoreResolveResultState || (StoreResolveResultState = {}));
var HttpStatusCode;
(function (HttpStatusCode) {
    HttpStatusCode[HttpStatusCode["Ok"] = 200] = "Ok";
    HttpStatusCode[HttpStatusCode["Created"] = 201] = "Created";
    HttpStatusCode[HttpStatusCode["NoContent"] = 204] = "NoContent";
    HttpStatusCode[HttpStatusCode["NotModified"] = 304] = "NotModified";
    HttpStatusCode[HttpStatusCode["BadRequest"] = 400] = "BadRequest";
    HttpStatusCode[HttpStatusCode["Unauthorized"] = 401] = "Unauthorized";
    HttpStatusCode[HttpStatusCode["Forbidden"] = 403] = "Forbidden";
    HttpStatusCode[HttpStatusCode["NotFound"] = 404] = "NotFound";
    HttpStatusCode[HttpStatusCode["ServerError"] = 500] = "ServerError";
    HttpStatusCode[HttpStatusCode["GatewayTimeout"] = 504] = "GatewayTimeout";
})(HttpStatusCode || (HttpStatusCode = {}));
/**
 * A type guard function for determining if an unknown object is a {@link FormData}
 */
function isFormData(obj) {
    return (typeof obj === 'object' &&
        obj !== null &&
        'namedEntries' in obj &&
        isArray$1(obj.namedEntries));
}
/**
 * A type guard function for determining if an unknown object is a {@link FileReference}
 */
function isFileReference(entryValue) {
    return (typeof entryValue === 'object' &&
        entryValue !== null &&
        'isFileReference' in entryValue &&
        entryValue.isFileReference === true);
}
var GraphNodeType;
(function (GraphNodeType) {
    GraphNodeType["Link"] = "Link";
    GraphNodeType["Node"] = "Node";
    GraphNodeType["Error"] = "Error";
    GraphNodeType["Locked"] = "Locked";
})(GraphNodeType || (GraphNodeType = {}));

var StoreLinkStateValues;
(function (StoreLinkStateValues) {
    StoreLinkStateValues[StoreLinkStateValues["NotPresent"] = 0] = "NotPresent";
    StoreLinkStateValues[StoreLinkStateValues["RefNotPresent"] = 1] = "RefNotPresent";
    StoreLinkStateValues[StoreLinkStateValues["RefPresent"] = 2] = "RefPresent";
    StoreLinkStateValues[StoreLinkStateValues["Null"] = 3] = "Null";
    StoreLinkStateValues[StoreLinkStateValues["Missing"] = 4] = "Missing";
    StoreLinkStateValues[StoreLinkStateValues["Pending"] = 5] = "Pending";
})(StoreLinkStateValues || (StoreLinkStateValues = {}));
var FragmentReadResultState;
(function (FragmentReadResultState) {
    FragmentReadResultState[FragmentReadResultState["Missing"] = 0] = "Missing";
    FragmentReadResultState[FragmentReadResultState["Success"] = 1] = "Success";
    FragmentReadResultState[FragmentReadResultState["Error"] = 2] = "Error";
})(FragmentReadResultState || (FragmentReadResultState = {}));
({
    state: FragmentReadResultState.Missing,
});

var ResourceParamType;
(function (ResourceParamType) {
    ResourceParamType[ResourceParamType["UrlParameter"] = 0] = "UrlParameter";
    ResourceParamType[ResourceParamType["QueryParameter"] = 1] = "QueryParameter";
    ResourceParamType[ResourceParamType["Body"] = 2] = "Body";
    ResourceParamType[ResourceParamType["Header"] = 3] = "Header";
})(ResourceParamType || (ResourceParamType = {}));
var TypeCheckShapes;
(function (TypeCheckShapes) {
    TypeCheckShapes[TypeCheckShapes["String"] = 0] = "String";
    TypeCheckShapes[TypeCheckShapes["Boolean"] = 1] = "Boolean";
    TypeCheckShapes[TypeCheckShapes["Number"] = 2] = "Number";
    TypeCheckShapes[TypeCheckShapes["Integer"] = 3] = "Integer";
    TypeCheckShapes[TypeCheckShapes["Unsupported"] = 4] = "Unsupported";
})(TypeCheckShapes || (TypeCheckShapes = {}));
// engine version: 0.156.4-dev2-78889b7e

const { keys: keys$1 } = Object;

// we're going to intentionally bundle this small bit of luvio engine code into
// this module to keep it runtime dependency-free
const fetchNetworkAdapter = async (resourceRequest, _resourceRequestContext) => {
    const { baseUri, basePath, body: requestBody, queryParams, method, headers } = resourceRequest;
    const qs = generateQueryString(queryParams);
    const path = `${baseUri}${basePath}${qs}`;
    let body;
    // some endpoints use FormData for POST request body, check here
    // if we have a POST body that is FormData
    if (method === 'post' && isFormData(requestBody)) {
        // we will populate a DOM FormData and pass that to fetch
        const newForm = new FormData();
        for (const { name, value } of requestBody.namedEntries) {
            // if this is a string or real DOM File then we can
            // just add it to FormData
            if (typeof value === 'string' || value instanceof File) {
                newForm.append(name, value);
            }
            // this network adapter doesn't currently support FileReference's
            else if (isFileReference(value)) {
                throw Error(`Luvio fetchNetworkAdapter does not support FileReference's`);
            }
            // else we have a Luvio File that isn't a real DOM file,
            // so we need to turn it into a DOM file
            else {
                const buffer = await value.arrayBuffer();
                newForm.append(name, new File([new Uint8Array(buffer)], value.name, {
                    type: value.type,
                }));
            }
        }
        body = newForm;
    }
    else if (requestBody === null) {
        body = null;
    }
    else {
        body = JSON.stringify(requestBody);
        headers['Content-Type'] = 'application/json';
    }
    const response = await fetch(path, {
        method: method.toUpperCase(),
        headers: generateHeaders(headers),
        body,
    });
    const { status, ok, statusText } = response;
    // coerce headers
    const responseHeaders = {};
    response.headers.forEach((value, key) => {
        responseHeaders[key] = value;
    });
    // parse body
    let responseBody = null;
    if (status !== 204) {
        const contentType = responseHeaders['content-type'];
        responseBody =
            contentType && contentType.startsWith('application/json')
                ? await response.json()
                : await response.text();
    }
    return {
        body: responseBody,
        status,
        statusText,
        ok,
        headers: responseHeaders,
    };
};
function generateQueryString(params) {
    const queryStrings = [];
    for (const key of keys$1(params)) {
        queryStrings.push(`${key}=${params[key]}`);
    }
    if (queryStrings.length > 0) {
        return `?${queryStrings.join('&')}`;
    }
    return '';
}
function generateHeaders(headers) {
    const fetchHeaders = new Headers();
    for (const key of keys$1(headers)) {
        fetchHeaders.set(key, headers[key]);
    }
    return fetchHeaders;
}

class LdsNetworkAdapterErrorResponse extends Error {
    constructor(message, _error) {
        super(message);
        this._error = _error;
        this.errorType = 'networkAdapterError';
        this.name = this.constructor.name;
    }
}
function isPromise(value) {
    // check for Thenable due to test frameworks using custom Promise impls
    return value !== null && value !== undefined && typeof value.then === 'function';
}

function e(e){this.message=e;}e.prototype=new Error,e.prototype.name="InvalidCharacterError";var r="undefined"!=typeof window&&window.atob&&window.atob.bind(window)||function(r){var t=String(r).replace(/=+$/,"");if(t.length%4==1)throw new e("'atob' failed: The string to be decoded is not correctly encoded.");for(var n,o,a=0,i=0,c="";o=t.charAt(i++);~o&&(n=a%4?64*n+o:o,a++%4)?c+=String.fromCharCode(255&n>>(-2*a&6)):0)o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(o);return c};function t(e){var t=e.replace(/-/g,"+").replace(/_/g,"/");switch(t.length%4){case 0:break;case 2:t+="==";break;case 3:t+="=";break;default:throw "Illegal base64url string!"}try{return function(e){return decodeURIComponent(r(e).replace(/(.)/g,(function(e,r){var t=r.charCodeAt(0).toString(16).toUpperCase();return t.length<2&&(t="0"+t),"%"+t})))}(t)}catch(e){return r(t)}}function n(e){this.message=e;}function o(e,r){if("string"!=typeof e)throw new n("Invalid token specified");var o=!0===(r=r||{}).header?0:1;try{return JSON.parse(t(e.split(".")[o]))}catch(e){throw new n("Invalid token specified: "+e.message)}}n.prototype=new Error,n.prototype.name="InvalidTokenError";

/**
 * Copyright (c) 2022, Salesforce, Inc.,
 * All rights reserved.
 * For full license text, see the LICENSE.txt file
 */


const { parse, stringify } = JSON;
const { join, push, unshift } = Array.prototype;
const { isArray } = Array;
const { entries, keys } = Object;

const UI_API_BASE_URI = '/services/data/v62.0/ui-api';

const LDS_RECORDS_AGGREGATE_UI = 'LDS_Records_AggregateUi';
// Boundary which represents the limit that we start chunking at,
// determined by comma separated string length of fields
const MAX_STRING_LENGTH_PER_CHUNK = 10000;
// UIAPI limit
const MAX_AGGREGATE_UI_CHUNK_LIMIT = 50;
function createOkResponse(body) {
    return {
        status: HttpStatusCode$1.Ok,
        body,
        statusText: 'ok',
        headers: {},
        ok: true,
    };
}
function getErrorResponseText(status) {
    switch (status) {
        case HttpStatusCode$1.Ok:
            return 'OK';
        case HttpStatusCode$1.NotModified:
            return 'Not Modified';
        case HttpStatusCode$1.NotFound:
            return 'Not Found';
        case HttpStatusCode$1.BadRequest:
            return 'Bad Request';
        case HttpStatusCode$1.ServerError:
            return 'Server Error';
        default:
            return `Unexpected HTTP Status Code: ${status}`;
    }
}
function createErrorResponse(status, body) {
    return {
        status,
        body,
        statusText: getErrorResponseText(status),
        headers: {},
        ok: false,
    };
}
function isSpanningRecord(fieldValue) {
    return fieldValue !== null && typeof fieldValue === 'object';
}
function mergeRecordFields(first, second) {
    const { fields: targetFields } = first;
    const { fields: sourceFields } = second;
    const fieldNames = keys(sourceFields);
    for (let i = 0, len = fieldNames.length; i < len; i += 1) {
        const fieldName = fieldNames[i];
        const sourceField = sourceFields[fieldName];
        const targetField = targetFields[fieldName];
        if (isSpanningRecord(sourceField.value)) {
            if (targetField === undefined) {
                targetFields[fieldName] = sourceFields[fieldName];
                continue;
            }
            mergeRecordFields(targetField.value, sourceField.value);
            continue;
        }
        targetFields[fieldName] = sourceFields[fieldName];
    }
    return first;
}
/** Invoke executeAggregateUi Aura controller.  This is only to be used with large getRecord requests that
 *  would otherwise cause a query length exception.
 */
function dispatchSplitRecordAggregateUiAction(recordId, networkAdapter, resourceRequest, resourceRequestContext) {
    return networkAdapter(resourceRequest, resourceRequestContext).then((resp) => {
        const { body } = resp;
        // This response body could be an executeAggregateUi, which we don't natively support.
        // Massage it into looking like a getRecord response.
        if (body === null ||
            body === undefined ||
            body.compositeResponse === undefined ||
            body.compositeResponse.length === 0) {
            // We shouldn't even get into this state - a 200 with no body?
            throw createErrorResponse(HttpStatusCode$1.ServerError, {
                error: 'No response body in executeAggregateUi found',
            });
        }
        const merged = body.compositeResponse.reduce((seed, response) => {
            if (response.httpStatusCode !== HttpStatusCode$1.Ok) {
                throw createErrorResponse(HttpStatusCode$1.ServerError, {
                    error: response.message,
                });
            }
            if (seed === null) {
                return response.body;
            }
            return mergeRecordFields(seed, response.body);
        }, null);
        return createOkResponse(merged);
    }, (err) => {
        // rethrow error
        throw err;
    });
}
function shouldUseAggregateUiForGetRecord(fieldsArray, optionalFieldsArray) {
    return fieldsArray.length + optionalFieldsArray.length >= MAX_STRING_LENGTH_PER_CHUNK;
}
function buildAggregateUiUrl(params, resourceRequest) {
    const { fields, optionalFields } = params;
    const queryString = [];
    if (fields !== undefined && fields.length > 0) {
        const fieldString = join.call(fields, ',');
        push.call(queryString, `fields=${encodeURIComponent(fieldString)}`);
    }
    if (optionalFields !== undefined && optionalFields.length > 0) {
        const optionalFieldString = join.call(optionalFields, ',');
        push.call(queryString, `optionalFields=${encodeURIComponent(optionalFieldString)}`);
    }
    return `${resourceRequest.baseUri}${resourceRequest.basePath}?${join.call(queryString, '&')}`;
}
function buildGetRecordByFieldsCompositeRequest(resourceRequest, recordsCompositeRequest) {
    const { fieldsArray, optionalFieldsArray, fieldsLength, optionalFieldsLength } = recordsCompositeRequest;
    // Formula:  # of fields per chunk = floor(avg field length / max length per chunk)
    const averageFieldStringLength = Math.floor((fieldsLength + optionalFieldsLength) / (fieldsArray.length + optionalFieldsArray.length));
    const fieldsPerChunk = Math.floor(MAX_STRING_LENGTH_PER_CHUNK / averageFieldStringLength);
    const optionalFieldsChunks = [];
    // Do the same for optional tracked fields
    for (let i = 0, j = optionalFieldsArray.length; i < j; i += fieldsPerChunk) {
        const newChunk = optionalFieldsArray.slice(i, i + fieldsPerChunk);
        push.call(optionalFieldsChunks, newChunk);
    }
    const compositeRequest = [];
    // Add fields as one chunk at the beginning of the compositeRequest
    if (fieldsArray.length > 0) {
        const url = buildAggregateUiUrl({
            fields: fieldsArray,
        }, resourceRequest);
        push.call(compositeRequest, {
            url,
            referenceId: `${LDS_RECORDS_AGGREGATE_UI}_fields`,
        });
    }
    // Make sure we don't exceed the max subquery chunk limit for aggUi by capping the amount
    // of optionalFields subqueries at MAX_AGGREGATE_UI_CHUNK_LIMIT - 1 (first chunk is for fields)
    const maxNumberOfAllowableOptionalFieldsChunks = MAX_AGGREGATE_UI_CHUNK_LIMIT - 1;
    const optionalFieldsChunksLength = Math.min(optionalFieldsChunks.length, maxNumberOfAllowableOptionalFieldsChunks);
    for (let i = 0; i < optionalFieldsChunksLength; i += 1) {
        const fieldChunk = optionalFieldsChunks[i];
        const url = buildAggregateUiUrl({
            optionalFields: fieldChunk,
        }, resourceRequest);
        push.call(compositeRequest, {
            url,
            referenceId: `${LDS_RECORDS_AGGREGATE_UI}_optionalFields_${i}`,
        });
    }
    return compositeRequest;
}

const UIAPI_RECORDS_PATH = `${UI_API_BASE_URI}/records`;
const UIAPI_RECORDS_BATCH_PATH = `${UI_API_BASE_URI}/records/batch/`;
const QUERY_TOO_COMPLICATED_ERROR_CODE = 'QUERY_TOO_COMPLICATED';
function fetchResponseIsQueryTooComplicated(error) {
    const { body } = error;
    if (error.status === HttpStatusCode$1.BadRequest && body !== undefined) {
        return (body.statusCode === HttpStatusCode$1.BadRequest &&
            body.errorCode === QUERY_TOO_COMPLICATED_ERROR_CODE);
    }
    return false;
}
/*
 * Takes a ResourceRequest, builds the aggregateUi payload, and dispatches via aggregateUi action
 */
function buildAndDispatchGetRecordAggregateUi(recordId, req, params) {
    const { networkAdapter, resourceRequest, resourceRequestContext } = req;
    const compositeRequest = buildGetRecordByFieldsCompositeRequest(resourceRequest, params);
    const aggregateUiParams = {
        compositeRequest,
    };
    const aggregateUiResourceRequest = {
        baseUri: UI_API_BASE_URI,
        basePath: '/aggregate-ui',
        method: 'post',
        priority: resourceRequest.priority,
        urlParams: {},
        body: aggregateUiParams,
        queryParams: {},
        headers: {},
    };
    return dispatchSplitRecordAggregateUiAction(recordId, networkAdapter, aggregateUiResourceRequest, resourceRequestContext);
}
const getRecordDispatcher = (req) => {
    const { resourceRequest, networkAdapter, resourceRequestContext } = req;
    const { queryParams, urlParams } = resourceRequest;
    const { fields, optionalFields } = queryParams;
    if (process.env.NODE_ENV !== 'production') {
        if (typeof urlParams.recordId !== 'string') {
            throw new Error(`Invalid recordId: expected string, recieved "${typeof urlParams.recordId}"`);
        }
    }
    const recordId = urlParams.recordId;
    const fieldsArray = fields !== undefined && isArray(fields) ? fields : [];
    const optionalFieldsArray = optionalFields !== undefined && Array.isArray(optionalFields)
        ? optionalFields
        : [];
    const fieldsString = fieldsArray.join(',');
    const optionalFieldsString = optionalFieldsArray.join(',');
    // Don't submit a megarequest to UIAPI due to SOQL limit reasons.
    // Split and aggregate if needed
    const useAggregateUi = shouldUseAggregateUiForGetRecord(fieldsString, optionalFieldsString);
    if (useAggregateUi) {
        return buildAndDispatchGetRecordAggregateUi(recordId, {
            networkAdapter,
            resourceRequest,
            resourceRequestContext,
        }, {
            fieldsArray,
            optionalFieldsArray,
            fieldsLength: fieldsString.length,
            optionalFieldsLength: optionalFieldsString.length,
        });
    }
    return defaultDispatcher(req).catch((err) => {
        if (fetchResponseIsQueryTooComplicated(err)) {
            // Retry with aggregateUi to see if we can avoid Query Too Complicated
            return buildAndDispatchGetRecordAggregateUi(recordId, {
                networkAdapter,
                resourceRequest,
                resourceRequestContext,
            }, {
                fieldsArray,
                optionalFieldsArray,
                fieldsLength: fieldsString.length,
                optionalFieldsLength: optionalFieldsString.length,
            });
        }
        else {
            throw err;
        }
    });
};
function matchRecordsHandlers(path, resourceRequest) {
    const method = resourceRequest.method.toLowerCase();
    if (method === 'get' &&
        path.startsWith(UIAPI_RECORDS_PATH) &&
        path.startsWith(UIAPI_RECORDS_BATCH_PATH) === false) {
        return getRecordDispatcher;
    }
    return null;
}

const defaultDispatcher = (req) => {
    const { networkAdapter, resourceRequest, resourceRequestContext } = req;
    return networkAdapter(resourceRequest, resourceRequestContext);
};
function getDispatcher(resourceRequest) {
    const { basePath, baseUri } = resourceRequest;
    const path = `${baseUri}${basePath}`;
    const recordsMatch = matchRecordsHandlers(path, resourceRequest);
    if (recordsMatch !== null) {
        return recordsMatch;
    }
    return defaultDispatcher;
}

const inflightRequests = Object.create(null);
const TRANSACTION_KEY_SEP = '::';
const EMPTY_STRING = '';
function isResourceRequestDedupable(resourceRequest) {
    const resourceRequestContext = resourceRequest.resourceRequestContext;
    return (resourceRequest.resourceRequest.method.toLowerCase() === 'get' ||
        (resourceRequestContext && resourceRequestContext.luvioRequestMethod === 'get'));
}
function getTransactionKey(req) {
    const { resourceRequest } = req;
    const { baseUri, basePath, queryParams, headers } = resourceRequest;
    const path = `${baseUri}${basePath}`;
    const queryParamsString = queryParams ? stringify(queryParams) : EMPTY_STRING;
    const headersString = stringify(headers);
    const bodyString = resourceRequest.body && isResourceRequestDedupable(req)
        ? stringify(resourceRequest.body)
        : EMPTY_STRING;
    return `${path}${TRANSACTION_KEY_SEP}${headersString}${TRANSACTION_KEY_SEP}${queryParamsString}${bodyString}`;
}
function getFulfillingRequest(inflightRequests, resourceRequest) {
    const { fulfill } = resourceRequest;
    if (fulfill === undefined) {
        return null;
    }
    const handlersMap = entries(inflightRequests);
    for (let i = 0, len = handlersMap.length; i < len; i += 1) {
        const [transactionKey, handlers] = handlersMap[i];
        // check fulfillment against only the first handler ([0]) because it's equal or
        // fulfills all subsequent handlers in the array
        const existing = handlers[0].resourceRequest;
        if (fulfill(existing, resourceRequest) === true) {
            return transactionKey;
        }
    }
    return null;
}
/**
  Dedupes network requests being made to Salesforce APIs
  This function is only designed to dedupe GET requests.

  If POST/PUT/PATCH/DELETE requests need to be deduped, that should be handled
  on the server instead of here.
*/
const dedupeRequest = (req) => {
    const { resourceRequest } = req;
    if (process.env.NODE_ENV !== 'production') {
        if (!isResourceRequestDedupable(req)) {
            throw new Error('Invalid ResourceRequest that cannot be deduped. Only "get" Requests supported.');
        }
    }
    const transactionKey = getTransactionKey(req);
    // if an identical request is in-flight then queue for its response (do not re-issue the request)
    if (transactionKey in inflightRequests) {
        return new Promise((resolve, reject) => {
            push.call(inflightRequests[transactionKey], {
                resolve,
                reject,
                resourceRequest,
            });
        });
    }
    const dispatch = getDispatcher(resourceRequest);
    // fallback to checking a custom deduper to find a similar (but not identical) request
    const similarTransactionKey = getFulfillingRequest(inflightRequests, resourceRequest);
    if (similarTransactionKey !== null) {
        return new Promise((resolve) => {
            // custom dedupers find similar (not identical) requests. if the similar request fails
            // there's no guarantee the deduped request should fail. thus we re-issue the
            // original request in the case of a failure
            push.call(inflightRequests[similarTransactionKey], {
                resolve,
                reject: function reissueRequest() {
                    resolve(dispatch(req));
                },
                resourceRequest,
            });
        });
    }
    dispatch(req).then((response) => {
        const handlers = inflightRequests[transactionKey];
        delete inflightRequests[transactionKey];
        // handlers mutate responses so must clone the response for each.
        // the first handler is given the original version to avoid an
        // extra clone (particularly when there's only 1 handler).
        for (let i = 1, len = handlers.length; i < len; i++) {
            const handler = handlers[i];
            handler.resolve(parse(stringify(response)));
        }
        handlers[0].resolve(response);
    }, (error) => {
        const handlers = inflightRequests[transactionKey];
        delete inflightRequests[transactionKey];
        for (let i = 0, len = handlers.length; i < len; i++) {
            const handler = handlers[i];
            handler.reject(error);
        }
    });
    // rely on sync behavior of Promise creation to create the list for handlers
    return new Promise((resolve, reject) => {
        inflightRequests[transactionKey] = [{ resolve, reject, resourceRequest }];
    });
};

const RATE_LIMIT_CONFIG = {
    bucketCapacity: 100,
    fillsPerSecond: 100,
};
class TokenBucket {
    /**
     * Constructs an instance of Token Bucket for rate limiting
     *
     * @param bucket The token holding capacity of the bucket
     * @param refillTokensPerSecond The number of tokens replenished every second
     */
    constructor(config) {
        this.bucketCapacity = config.bucketCapacity;
        this.refillTokensPerMilliSecond = config.fillsPerSecond / 1000;
        this.tokens = config.bucketCapacity;
        this.lastRefillTime = Date.now();
    }
    /**
     * Refills the bucket and removes desired number of tokens
     *
     * @param removeTokens number of tokens to be removed from the bucket should be >= 0
     * @returns {boolean} true if removing token was succesful
     */
    take(removeTokens) {
        // refill tokens before removing
        this.refill();
        const { tokens } = this;
        const remainingTokens = tokens - removeTokens;
        if (remainingTokens >= 0) {
            this.tokens = remainingTokens;
            return true;
        }
        return false;
    }
    refill() {
        const { bucketCapacity, tokens, refillTokensPerMilliSecond, lastRefillTime } = this;
        const now = Date.now();
        const timePassed = now - lastRefillTime;
        // Number of tokens should be integer so something like Math.floor is desired
        // Using Bitwise NOT ~ twice will achieve the same result with performance benefits
        const calculatedTokens = tokens + ~~(timePassed * refillTokensPerMilliSecond);
        this.tokens = bucketCapacity < calculatedTokens ? bucketCapacity : calculatedTokens;
        this.lastRefillTime = now;
    }
}
var tokenBucket = new TokenBucket(RATE_LIMIT_CONFIG);

function platformNetworkAdapter(baseNetworkAdapter) {
    return (resourceRequest, resourceRequestContext) => {
        if (!tokenBucket.take(1)) ;
        const salesforceRequest = {
            networkAdapter: baseNetworkAdapter,
            resourceRequest: resourceRequest,
            resourceRequestContext: resourceRequestContext,
        };
        // If GET, or overriden to be treated as a GET with resourceRequestContext.networkResourceOverride, then dedupe.
        if (isResourceRequestDedupable(salesforceRequest)) {
            return dedupeRequest(salesforceRequest);
        }
        else {
            const dispatch = getDispatcher(resourceRequest);
            return dispatch(salesforceRequest);
        }
    };
}

const NO_OP = () => { };
// For use by callers within this module to instrument interesting things.
const instrumentation = {
    log: NO_OP,
    error: NO_OP,
};
/**
 * Allows external modules (typically a runtime environment) to set
 * instrumentation hooks for this module. Note that the hooks are
 * incremental - hooks not suppiled in newInstrumentation will retain
 * their previous values. The default instrumentation hooks are no-ops.
 *
 * @param newInstrumentation instrumentation hooks to be overridden
 */
function instrument(newInstrumentation) {
    Object.assign(instrumentation, newInstrumentation);
}

// noop implementation for when one is not provided
let internalRequestTracker = {
    registerHandler: (_request, _name, _loadedCheck) => { },
    markFinished: (_request) => { },
};
// noop implementation for when one is not provided
let internalRequestLogger = {
    resolve: (_request, _response) => { },
    reject: (_request, _error) => { },
};
/**
 * Adds Authentication for the provided {@link ResourceRequest}
 *
 * @param resourceRequest
 * @param jwt
 * @return
 */
function authenticateRequest(resourceRequest, jwt) {
    const { token } = jwt;
    const { headers } = resourceRequest;
    // Only supporting Bearer <auth-scheme>
    const authenticatedHeaders = {
        ...headers,
        Authorization: `Bearer ${token}`,
    };
    return {
        ...resourceRequest,
        headers: authenticatedHeaders,
    };
}
const platformFetchAdapter = platformNetworkAdapter(fetchNetworkAdapter);
/**
 * Wrapper around fetch network adapter from luvio with access to JwtManager {@link JwtManager} to authenticate Request
 * And a hook to update the base URI for the provided {@link ResourceRequest}
 *
 * @param jwtManager: {@link JwtManager}
 * @param modifyResourceRequestHook: {@link ModifyResourceRequestHook}
 * @returns jwtNetworkAdapter {@link NetworkAdapter}
 */
function setupJwtNetworkAdapter(jwtManager, modifyResourceRequestHook) {
    const jwtNetworkAdapter = async (resourceRequest, resourceRequestContext) => {
        let jwtToken;
        try {
            jwtToken = await jwtManager.getJwt();
        }
        catch (error) {
            if (process.env.NODE_ENV !== 'production') {
                throw new Error(`There was an error while fetching Jwt token: ${JSON.stringify(error)}`);
            }
            return Promise.reject(new LdsNetworkAdapterErrorResponse('Unable to fetch the jwt required to make this request', error));
        }
        let authenticatedRequest = authenticateRequest(resourceRequest, jwtToken);
        if (modifyResourceRequestHook) {
            authenticatedRequest = modifyResourceRequestHook(authenticatedRequest, jwtToken);
        }
        return fetchNetworkAdapter(authenticatedRequest);
    };
    return jwtNetworkAdapter;
}
let cachedLexJwtToken;
/**
 * Helper function to store/decode the JWT and cache it.
 * @param lexJwt - The jwt from aura client service api.
 * @returns JwtToken
 */
function decodeAndCacheNewLexJwtToken(lexJwt) {
    if (cachedLexJwtToken === undefined || lexJwt.jwt !== cachedLexJwtToken.token) {
        cachedLexJwtToken = new JwtToken(lexJwt.jwt, o(lexJwt.jwt), lexJwt.extraInfo);
    }
    return cachedLexJwtToken;
}
/**
 * Authenticate the request with the JWT token, and modify it if modifyResourceRequestHook is provided
 * @param resourceRequest - The resource request.
 * @param modifyResourceRequestHook - Function to modify the request based on the JWT.
 * @returns The autheticated request.
 */
function authorizeRequestWithJwt(resourceRequest, modifyResourceRequestHook) {
    let authenticatedRequest = authenticateRequest(resourceRequest, cachedLexJwtToken);
    if (modifyResourceRequestHook) {
        authenticatedRequest = modifyResourceRequestHook(authenticatedRequest, cachedLexJwtToken);
    }
    return authenticatedRequest;
}
/**
 * Helper function to decode/cache the JWT Token if it's new/changed, authorize the request with JWT, and make the fetch network call.
 * @param resourceRequest - {@link ResourceRequest}
 * @param resourceRequestContext {@link ResourceRequestContext}
 * @param lexJwt - The JWT recieved from LWPCS API.
 * @param modifyResourceRequestHook - {@link ModifyResourceRequestHook}
 * @returns Promise<FetchResponse<any>>
 */
function handleJwtAndSendFetchRequest(resourceRequest, resourceRequestContext, lexJwt, modifyResourceRequestHook) {
    const { baseUri, basePath } = resourceRequest;
    const path = `${baseUri}${basePath}`;
    const storageAndLogger = getStorageAndLogger(path);
    const transactionKey = getTransactionKey$1(resourceRequest);
    decodeAndCacheNewLexJwtToken(lexJwt);
    const authorizedRequest = authorizeRequestWithJwt(resourceRequest, modifyResourceRequestHook);
    const response = checkLdsStorageCacheOrFetch(authorizedRequest, resourceRequestContext, storageAndLogger, transactionKey);
    internalRequestTracker.registerHandler(response, 'lds-inflight-network-request', () => {
        // return false until we signal we are finished
        return false;
    });
    response
        .then((value) => {
        // W-16105234
        // To-do if needed: While testing locally, I saw this HTTP response from a request. I'm not sure if it's because I was
        // paused while debugging and the fetched JWT then expired, but if we encounter more issues it would be good to log/capture
        // data if needed to diagnose.
        /**
     * {
            "body": [
                {
                    "message": "INVALID_JWT_FORMAT",
                    "errorCode": "INVALID_AUTH_HEADER"
                }
            ],
            "status": 401,
            "statusText": "",
            "ok": false,
            "headers": {
                "cache-control": "no-cache,must-revalidate,max-age=0,no-store,private",
                "content-type": "application/json;charset=UTF-8"
            }
        }
    **/
        if (storageAndLogger !== null && storageAndLogger.storage !== null) {
            storageAndLogger.storage.set(transactionKey, value.body).catch((_error) => { });
        }
        internalRequestLogger.resolve(resourceRequest, value);
    })
        .catch((error) => {
        internalRequestLogger.reject(resourceRequest, error);
    });
    return response.finally(() => {
        internalRequestTracker.markFinished(response);
    });
}
const layoutUserStateStorageConfig = {
    storage: layoutUserStateStorage,
    statsLogger: layoutUserStateStorageStatsLogger,
};
const layoutStorageConfig = {
    storage: layoutStorage,
    statsLogger: layoutStorageStatsLogger,
};
const objectInfoStorageConfig = {
    storage: objectInfoStorage,
    statsLogger: objectInfoStorageStatsLogger,
};
/**
 * Given a path, return the aura storage/logger reference if we store the resource durably for network-based caching.
 * @param path - The base path for the request.
 * @returns LdsStorageConfig if we cache that resource, otherwise null.
 */
function getStorageAndLogger(path) {
    if (path.startsWith(UIAPI_GET_LAYOUT) && path.endsWith(UIAPI_GET_LAYOUT_USER_STATE)) {
        // getLayoutUserState
        return layoutUserStateStorageConfig;
    }
    else if (path.startsWith(UIAPI_GET_LAYOUT) &&
        path.endsWith(UIAPI_GET_LAYOUT_USER_STATE) === false) {
        // getLayout
        return layoutStorageConfig;
    }
    else if (path.startsWith(UIAPI_OBJECT_INFO_BATCH_PATH)) {
        // getObjectInfos
        return objectInfoStorageConfig;
    }
    else if (path.startsWith(UIAPI_OBJECT_INFO_PATH) &&
        path.startsWith(UIAPI_OBJECT_INFO_BATCH_PATH) === false &&
        /picklist-values\/[a-zA-Z\d]+\/[a-zA-Z\d]+/.test(path) === false &&
        /picklist-values\/[a-zA-Z\d]+/.test(path) === false) {
        // getObjectInfo
        return objectInfoStorageConfig;
    }
    return null;
}
/**
 * Helper function to fetch data, if available in aura storage cache returns that instead of going to network.
 * @param resourceRequest - {@link ResourceRequest}
 * @param resourceRequestContext {@link ResourceRequestContext}
 * @param storageAndLogger - Object containing a reference to aura storage/logger
 * @param transactionKey - The transaction key, derived from the resource request params.
 * @returns Promise<FetchResponse<any> - Promise that resolves to a fetch response.
 */
function checkLdsStorageCacheOrFetch(resourceRequest, resourceRequestContext, storageAndLogger, transactionKey) {
    if (!shouldForceRefresh(resourceRequest)) {
        if (storageAndLogger !== null && storageAndLogger.storage !== null) {
            return storageAndLogger.storage.get(transactionKey).then((cacheResult) => {
                if (cacheResult !== undefined) {
                    storageAndLogger.statsLogger.logHits();
                    // This creates an AuraFetchResponse, should it just be FetchResponse?
                    return createOkResponse$1(cacheResult);
                }
                storageAndLogger.statsLogger.logMisses();
                return platformFetchAdapter(resourceRequest, resourceRequestContext);
            }, () => {
                return platformFetchAdapter(resourceRequest, resourceRequestContext);
            });
        }
    }
    return platformFetchAdapter(resourceRequest, resourceRequestContext);
}
/**
 * Wrapper around fetch network adapter from luvio with access to Aura Client Service getJwtAuthToken() to authenticate Request
 * And a hook to update the base URI for the provided {@link ResourceRequest}
 *
 * @param auraNetworkAdapter: {@link NetworkAdapter}
 * @param modifyResourceRequestHook: {@link ModifyResourceRequestHook}
 * @returns lexJwtNetworkAdapter {@link NetworkAdapter}
 */
function setupLexJwtNetworkAdapter(auraNetworkAdapter, modifyResourceRequestHook, requestTracker, requestLogger) {
    internalRequestTracker = requestTracker || internalRequestTracker;
    internalRequestLogger = requestLogger || internalRequestLogger;
    const lexJwtNetworkAdapter = async (resourceRequest, resourceRequestContext) => {
        let lexJwtOrPromise;
        try {
            // use `typeof window` since this won't throw if window isn't defined.
            const $A = typeof window !== 'undefined' ? window.$A : undefined;
            if ($A !== undefined) {
                // Call for JWT, Possible return values:
                // 1. AuraClientServiceJwt: If valid and stored by the API
                // 2. Promise<AuraClientServiceJwt>: If non-existent/invalid and requires network call to mint new API
                // 3. undefined: if JWT not available in environment
                lexJwtOrPromise = window.$A.clientService.getJwtAuthToken();
                if (isPromise(lexJwtOrPromise)) {
                    return lexJwtOrPromise
                        .then((lexJwt) => {
                        return handleJwtAndSendFetchRequest(resourceRequest, resourceRequestContext, lexJwt, modifyResourceRequestHook);
                    })
                        .catch((error) => {
                        if (process.env.NODE_ENV !== 'production') {
                            const errorMessage = error instanceof Error ? error.message : String(error);
                            // eslint-disable-next-line no-console
                            console.error(`There was an error while fetching Jwt token asynchronously: ${errorMessage}`);
                        }
                        instrumentation.error(error);
                        return auraNetworkAdapter(resourceRequest, resourceRequestContext);
                    });
                }
                else if (lexJwtOrPromise === undefined) {
                    instrumentation.error('getJwtAuthToken returned undefined, JWT not available in environment');
                    return auraNetworkAdapter(resourceRequest, resourceRequestContext);
                }
            }
            else {
                instrumentation.error('$A not defined');
                return auraNetworkAdapter(resourceRequest, resourceRequestContext);
            }
        }
        catch (error) {
            const errorMessage = error instanceof Error ? error.message : String(error);
            if (process.env.NODE_ENV !== 'production') {
                // eslint-disable-next-line no-console
                console.error(`There was an error while fetching Jwt token synchronously: ${errorMessage}`);
            }
            instrumentation.error(errorMessage);
            return auraNetworkAdapter(resourceRequest, resourceRequestContext);
        }
        return handleJwtAndSendFetchRequest(resourceRequest, resourceRequestContext, lexJwtOrPromise, modifyResourceRequestHook);
    };
    return lexJwtNetworkAdapter;
}

function buildJwtNetworkAdapter(jwtResolver, modifyResourceRequestHook) {
    const jwtManager = new JwtManager(new JwtRepository(), jwtResolver);
    return setupJwtNetworkAdapter(jwtManager, modifyResourceRequestHook);
}

export { buildJwtNetworkAdapter, instrument, setupJwtNetworkAdapter, setupLexJwtNetworkAdapter };
// version: 1.309.0-dev19-2af9db5954
